<template>
    <div>
        <div v-if="scoop_packages.on_error">
            <p>{{ scoop_packages?.on_error }}</p>
        </div>
        <div v-else-if="scoop_packages.on_success">
            <q-list bordered>
                <scoop-package-item v-for="scoop_package in scoop_packages.on_success" :scoop_package="scoop_package"
                    :key="scoop_package.name" />
            </q-list>

        </div>
    </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import ScoopPackageItem from './ScoopPackageItem.vue'
import { invoke } from '@tauri-apps/api'
import * as ST from './models'

export default defineComponent({
    data() {
        return {
            scoop_packages: {} as ST.FailableScoopPackage<ST.ScoopSearchResult[]>
        }
    },
    setup() {
        return {}
    },

    methods: {
        async scoop_search(searchTerm: string) {
            this.scoop_packages = await invoke('scoop_search', { searchTerm: searchTerm }) as ST.FailableScoopPackage<ST.ScoopSearchResult[]>
            this.scoop_packages.on_success?.forEach(pkg => pkg.additional_info = {})
        }
    },

    watch: {
        scoop_packages(new_packages: ST.FailableScoopPackage<ST.ScoopSearchResult[]>) {
            new_packages.on_success?.forEach(async pkg => {
                const cat = await invoke('scoop_cat', { packageName: pkg.name }) as ST.FailableScoopPackage<ST.ScoopCatResult>
                pkg.additional_info.cat = cat
            })
            new_packages.on_success?.forEach(async pkg => {
                const info = await invoke('scoop_info', { packageName: pkg.name }) as ST.FailableScoopPackage<ST.ScoopInfoResult>
                pkg.additional_info.info = info
            })
        }
    },

    components: { ScoopPackageItem }
})
</script>

<style scoped>
</style>